CHILD_DEL = 0
CHILD_ITEM = CHILD_DEL+1

CHILD_EDIT = CHILD_DEL+1
CHILD_EDIT_ITEM=CHILD_ITEM+1
CHILD_EDIT_ENTRY=CHILD_EDIT_ITEM+1

SUGGESTION_ACCEPT=0
SUGGESTION_REJECT=SUGGESTION_ACCEPT+1
SUGGESTION= SUGGESTION_REJECT+1
SUGGESTION_OWNER=SUGGESTION+1
SUGGESTION_CATEGORY=SUGGESTION_OWNER+1

jQuery ->
  unless checkPage(getHomeName()) then return

  $('#forum-senate-admin-lists').delegate 'input[id = delete-forum-object]','click', (evt) ->
    deleteForumObject(event.target)
  $('#forum-senate-admin-lists').delegate 'input[id = edit-forum-object]','click', (evt) ->
    openEditTopic(event.target)
  $('[id = forum-admin-button]').click ->
    doButtonAction(event.target)
    event.stopPropagation()
  $('#forum-senate-admin-users').delegate 'option[id = forum-admin-option]','click', (evt) ->
    checkForNone(event.target)
  $('#forum-category-admin').change ->
    getAdminsTopic()
  $('#forum-actions').change ->
    checkActionSetup(event.target)
  $('#forum-admin-language-select').change ->
    flipLanguage(event.target)
  $('#forum-actions').change ->
    handleActionChange(event.target)
  $('#forum-category-monitor').change ->
    monitorNewTopic()
#todo add reason selection for rejecion (forum and user privilages)

monitorNewTopic=->
  select = document.getElementById('forum-category-monitor').value
  $.post('forum_ajax', {function: 'get topics',list:'forum-topic-monitor', category: select, hold_test: false, restricted: false}, loadList)


getAdminCategory=->
  document.getElementById('forum-category-admin').value

handleActionChange=(which)->
  switch which.value
    when 'send email to'
      showMe({id:"forum-email-email"})
    else
      hideMe({id:"forum-email-email"})
doButtonAction = (which)->
  switch(which.name)
    when 'forum-add-topic'
      addTopic(which,getAdminCategory(),'me')
    when 'review-forum'
      setUpReview(which)
    when 'forum-activate-language'
      turnLanguage('on')
    when 'forum-deactivate-language'
      turnLanguage('off')
    when 'forum-add-category'
      addCategory(which,'me')
    when 'forum-add-language'
      addLanguage(which,'me')
    when 'forum-translate-topic'
      translateList(which)
    when 'forum-translate-category'
      translateList(which)
    when 'forum-user-tag-choose'
      setTagView()
    when 'forum-user-email-choose'
      setEmailView()
    when 'forum-act-on-admin-selector'
      doAction()
    when 'forum-add-cancel'
      addCancel({obj:which})
    when 'forum-admin-views'
     setAdminView(which)
    else

window.doAdminStuff = ->
  document.getElementById('forum-senate').dataset.admining = 'true'
  setAdminDisplay()
  $.post('forum_ajax',{function:'get list',by_name:false, list:'admin actions'},loadList)
  $.post('forum_ajax',{function:'get list',by_name:false, list:'admin distributions'},loadList)
  $.post('forum_ajax',{function:'get list',by_name:true, list:'admin emails'},loadList)
  $.post('forum_ajax',{function:'get list',by_name:true, list:'admin users'},loadList)

setAdminDisplay=->
  hideMe({id: 'review-forum-span'})
  hideMe({id: 'forum-senate'})
  showMe({id: 'forum-senate-admin'})
  hideMe({id: 'forum-user-tag-span'})
  hideMe({id: 'forum-user-email-span'})
  hideMe({id: 'forum-email-email'})
  showMe({name: 'forum-user-email-show'})
  showMe({name: 'forum-user-tag-show'})
  showMe({id:'forum-distribution-span'})
  hideMe({id:'forum-moderator-add-span'})

turnLanguage=(toggle)->
  showMe({id:'language-selector-span'})
  $.post('forum_ajax',{function:'get language set',list:'forum-admin-language-select',active:toggle =='off'},loadList)

checkForNone = (which)->
  if which.value == 'select none'
    hideMe({obj:which.parentNode.parentNode})
    name=which.parentNode.name + '-show'
    showMe({name:name})

setEmailView = ->
  blockMe({id:'forum-user-email-span'})
  hideMe({name:'forum-user-email-show'})
  $('#forum-user-email').focus()

setMonitorView=->
  hideMe({id:'forum-distribution-span'})
  showMe({id:'forum-moderator-add-span'})

setDistributionListView=->
  showMe({id:'forum-distribution-span'})
  hideMe({id:'forum-moderator-add-span'})

setTagView = ->
  blockMe({id:'forum-user-tag-span'})
  hideMe({name:'forum-user-tag-show'})
  $('#user-tag').focus()

checkActionSetup = (which)->
  switch which.value
    when 'create distribution'
      setDistributionListView()
    when 'add topic monitor'
      setMonitorView()
    else

flipLanguage=(selector)->
  select = getSelectValues({obj:selector,ref:false})
  $.post('forum_ajax',{function:'toggle language',language:select})
  selector.selectedIndex=0
  hideMe({id:'language-selector-span'})

doAction = ->
  request={}
  request.function = 'forum admin action'
  request.users1 = getSelectValues({name:'forum-user-tag',ref:false})
  request.users2 = getSelectValues({name:'forum-user-email',ref:false})
  request.subject = $('#forum-email-subject').val()
  request.body= $('#forum-email-body').val()
  request.topic=$('#forum-topic-monitor').val()
  $('#forum-email-body').val('')
  $('#forum-email-subject').val('')
  request.new_list_name = $('#forum-new-distribution-list').val()
  request.distribution_list = $('#forum-distribution-lists').val()
  request.forum_action = $('#forum-actions').val()
  document.getElementById('forum-actions').selectedIndex=0
  setAdminDisplay()
  $("forum-email-body").val('')
  $.post('forum_ajax',request)

setAdminView = (which_one)->
  switch(which_one.dataset.view)
    when 'lists'
      blockMe({id:'forum-senate-admin-lists'})
      hideMe({id:'forum-senate-admin-users'})
      addCancel({name:'category'})
      addCancel({name:'topic'})
      addCancel({name:'language'})
      $.post('forum_ajax',{function:'categories',list:'category', language:getLanguage(),hold_test:false,restricted:false},loadAdminsList)
      $.post('forum_ajax',{function:'get suggestions',list:'category'},loadCategorySuggestions)
      $.post('forum_ajax',{function:'get suggestions',list:'topic'},loadCategorySuggestions)
      $.post('forum_ajax',{function:'get suggestions',list:'language'},loadCategorySuggestions)
    when 'users'
      hideMe({id:'forum-senate-admin-lists'})
      blockMe({id:'forum-senate-admin-users'})
    else

setUpReview=(button)->
  if button.dataset.state == 'done'
    showMe(id:'forum-review-buttons')
    button.dataset.state = 'review'
    clearSenate()
    $.post('forum_ajax', {function: 'get senate', topic: getTopic(), review: true}, setSenate)
    button.value = button.dataset.done
  else
    button.dataset.state = 'done'
    hideMe(id:'forum-review-buttons')
    button.value= button.dataset.review
    clearSenate

deleteForumObject = (which_one)->
  id = which_one.dataset.target
  $.post('forum_ajax',{function:'remove forum object',id:which_one.dataset.id,state_action:which_one.value})
  if which_one.dataset.state == 'open'
    which_one.value = which_one.dataset.del
    document.getElementById(id).className = ''
    which_one.dataset.state = 'closed'
  else
    which_one.value = which_one.dataset.open
    document.getElementById(id).className = ''
    which_one.dataset.state= 'open'
  $.post('forum_ajax',{function:'categories',language:getLanguage(),hold_test:true,restricted:true},loadCategories)

addOptionTo = (which_one,item)->
  by_name=false
  switch which_one
    when 'category'
      pushOption($('[name=category_admin]'),{item:item,value:item},0)
      pushOption($('[name=category]'),{item:item,value:item},2)
    when 'language'
      pushOption($('[name=language]'),{item:item,value:item},1)
    else

translateList=(which)->
  if which.dataset.state == 'done'
    translateSetup({obj:which})
  else
    addCancel({obj:which})

addCategory = (which,user)->
  if which.dataset.state  == 'saved'
    addSetup({obj:which})
  else
    new_category = $('#forum-add-admin-category').val()
    unless new_category == ''
      addListEntry('forum-admins-category-list',{item:new_category})
      $.post('forum_ajax',{function:'add to list',list:'categories',new_item:new_category,user:$('#forum-add-admin-user').val()})
      addOptionTo('category',new_category)
    addCancel({obj:which})

addLanguage = (which,user)->
  if which.dataset.state == 'saved'
    addSetup({obj:which})
  else
    new_language = $('#forum-add-admin-language').val()
    new_local = $('#forum-add-admin-language-localized').val()
    new_code = $('#forum-add-admin-language-code')
    unless new_language == ''
      addListEntry('forum-admins-language-list',{item:new_language})
      $.post('forum_ajax',{function:'add to list',list:'language',language:new_language,local:new_local,code:new_code, user:$('#forum-add-admin-user').val()})
    addCancel({obj:which})

addTopic=(which,category,user)->
  if which.dataset.state == 'saved'
    addSetup({obj:which})
  else
    new_topic = $('#forum-add-admin-topic').val()
    unless  new_topic == ''
      addListEntry('forum-admins-topic-list',{item:new_topic,shift:true})
      $.post('forum_ajax',{function:'add to list',list:'topic', topic:new_topic,category:category,user:$('#forum-add-admin-user').val()})
    addCancel({obj:which})

addSetup=(params)->
  if params.name == undefined
    params.name = params.obj.name.split('-')[2]
    params.obj.value = params.obj.dataset.save
    params.obj.dataset.state='adding'
  hideMe({name:"forum-translate-#{params.name}"})
  $("input[data-who=#{params.name}]").show()  #show cancel button
  showMe({id:"forum-add-#{params.name}-input-span"})
  document.getElementById("forum-add-admin-#{params.name}").focus()

translateSetup=(params)->
  if params.name == undefined
    params.name = params.obj.name.split('-')[2]
    params.obj.value = params.obj.dataset.done
    params.obj.dataset.state='translating'
  document.getElementById('forum-admins-'+params.name+'-list').dataset.translating=true
  hideMe({name:"forum-add-#{params.name}"})
  $("input[data-who=#{params.name}]").show() #show cancel button
  document.getElementById("forum-add-admin-#{params.name}").focus()

addCancel=(params)->
  if params.name == undefined
    if params.obj.dataset.who == undefined then params.name = params.obj.name.split('-')[2]
    else params.name = params.obj.dataset.who
  button = $("[name = forum-add-#{params.name}]").get()[0]
  button.dataset.state = 'saved'
  button.value = button.dataset.add
  unless params.name == 'language'
    button2= $("[name = forum-translate-#{params.name}]").get()[0]
    button2.dataset.state='done'
    button2.value= button2.dataset.translate
    showMe({obj:button2})
    document.getElementById("forum-admins-#{params.name}-list").dataset.translating=false
  $("input[data-who=#{params.name}]").hide()
  hideMe({id:"forum-add-#{params.name}-input-span"})
  showMe({obj:button})
  showMe({name:"forum-add-#{params.name}"})
  $("[id = forum-add-admin-#{params.name}]").val('')
  $("[id = forum-add-admin-user]").val('me')

openEditTopic = (which_one)->
  line=  document.getElementById("edit-entry-#{which_one.dataset.id}")
  id=which_one.dataset.id
  if which_one.dataset.state == 'edit'
    parent = which_one.parentNode
    showMe({obj:parent.children[CHILD_EDIT_ENTRY]})
    which_one.value = which_one.dataset.save
    which_one.dataset.state = 'save'
    line.value = parent.children[CHILD_EDIT_ITEM].innerHTML
    hideMe({obj:parent.children[CHILD_EDIT_ITEM]})
    line.focus()
  else if which_one.dataset.state == 'save'
    parent = which_one.parentNode
    id = which_one.dataset.id
    which_one.dataset.state = 'edit'
    newline = line.value
    hideMe({obj:parent.children[CHILD_EDIT_ENTRY]})
    showMe({obj:parent.children[CHILD_EDIT_ITEM]})
    which_one.value = which_one.dataset.edit
    unless newline == ''
      translating=which_one.parentNode.parentElement.dataset.translating
      parent.children[CHILD_EDIT_ITEM].innerHTML = newline
      $.post('forum_ajax',{function:'edit forum topic',id:id,newline:newline,translating:translating})

getAdminCategories = ->
  $.post('forum_ajax',{function:'get categories',category:select,language:getLanguage(),list,'category',hold_test:false,restriced:false},loadAdminsList)

getAdminsTopic = ->
  select = document.getElementById('forum-category-admin').value
  $.post('forum_ajax',{function:'get topics',category:select,list:'topic',language:getLanguage(),hold_test:false,restricted:false},loadAdminsList)

window.loadAdminsList = (params)->
  list_data = params.list_data
  switch params.id
    when 'topic'
      which = 'forum-admins-topic-list'
      short = 0
      shift = true
    when 'category'
      which = 'forum-admins-category-list'
      short = 1
      shift = true
    else
  alist = document.getElementById(which).children
  dummy = alist[0]
  if dummy?
    for i in [1...alist.length]
      removeMe({obj:document.getElementById(which).children[1]})
  if list_data.length>0
    for i in [0...list_data.length-short]
      vars = list_data[i]
      vars.inert = i == 0||i == list_data.length-1-short
      vars.shift = shift
      if list_data[i].state?
        vars.state = list_data[i].state
      addListEntry(which,vars)
    removeMe({obj:dummy})
  else
    id = dummy.children[0].dataset.target
    document.getElementById(id).innerHTML = ''

addListEntry = (which,vars)->
  entry = document.getElementById(which).children[0].cloneNode(true)
  i = document.getElementById(which).children.length
  ref = document.getElementById(which).children[i-1]
  tag = which.split('-')[1]
  entry.children[CHILD_DEL].dataset.id = vars.id
  entry.children[CHILD_DEL].dataset.target = 'list-item-'+tag+'-'+i
  if vars.inert
    $(entry.children[CHILD_DEL]).val('----')
  else
    entry.children[CHILD_DEL].id = 'delete-forum-object'
    entry.children[CHILD_DEL].value= entry.children[CHILD_DEL].dataset.del
  entry.children[CHILD_EDIT].dataset.id = vars.id
  entry.children[CHILD_EDIT].dataset.target = 'list-item-'+tag+'-'+i
  entry.children[CHILD_EDIT].dataset.state = 'edit'
  entry.children[CHILD_EDIT_ITEM].innerHTML = vars.item
  entry.children[CHILD_EDIT_ITEM].id = 'list-item-'+tag+'-'+i
  entry.children[CHILD_EDIT_ENTRY].children[0].id="edit-entry-#{vars.id}"
  item=CHILD_EDIT_ITEM

  if vars.closed
    entry.children[item].className = 'forum-closed'
    entry.children[CHILD_DEL].value = entry.children[CHILD_DEL].dataset.open
    entry.children[CHILD_DEL].dataset.state  = 'closed'
  else
    entry.children[CHILD_DEL].dataset.state = 'open'
  document.getElementById(which).insertBefore(entry,ref)

loadCategorySuggestions = (params)->
  unless !params? || params.data.length == 0
    list = document.getElementById(params.list)
    list.style.display = 'none'
    for i in [0...params.data.length]
      pushElement(list,params.data[i],params.list)
    removeMe({obj:list.children[0]})

pushElement = (list,data,which)->
  entry = list.children[0].cloneNode(true)
  entry.id = 'list-' + which.split('-')[0]+ list.children.length
  entry.dataset.the_id = data.id
  entry.children[SUGGESTION_ACCEPT].dataset.id = list.children.length
  entry.children[SUGGESTION_REJECT].dataset.id = list.children.length
  entry.children[SUGGESTION].id = which.split('-')[0]+ '-item-'+ list.children.length
  entry.children[SUGGESTION_OWNER].id = which.split('-')[0]+ '-user-'+ list.children.length
  entry.children[SUGGESTION].innerHTML = data.suggestion
  entry.children[SUGGESTION_OWNER].innerHTML = "   |"+data.user+"|  "
  if data.category?
    entry.children[SUGGESTION_CATEGORY].innerHTML = data.category
    entry.children[SUGGESTION_CATEGORY].id = which.split('-')[0]+ '-category-'+ list.children.length
  list.appendChild(entry)

handleSuggestionResponse = (which_one)->
  if which_one.val() == 'accept'
    id = which_one.get()[0].dataset.id
    switch which_one.get()[0].parentNode.parentElement.id
      when 'category-prososals-list'
        $('#forum-add-admin-category').val($("span[id = category-item-#{id}]").get()[0].innerHTML)
        $('#forum-add-admin-user').val($("span[id = category-user-#{id}]").get()[0].innerHTML.split('|')[1])
        addCategory()
      when 'topic-prososals-list'
        $('#forum-add-admin-topic').val( $("span[id = topic-item-#{id}]").get()[0].innerHTML)
        $('#forum-add-admin-user').val($("span[id = topic-user-#{id}]").get()[0].innerHTML.split('|')[1])
        addTopic($("span[id = topic-category-#{id}]").get()[0].innerHTML.trim())
      when 'language-proposal-list'
        $('#forum-aadd-admin-language').val($("span[id = language-item-#{id}]").get()[0].innerHTML)
        $('#forum-add-admin-user').val($("span[id = language-user-#{id}]").get()[0].innerHTML.split('|')[1])
        addLanguage()
      else
  closeListItem(which_one)

closeListItem = (which_one)->
  id = which_one.get()[0].parentNode.dataset.the_id
  $.post('forum_ajax',{function:'suggestion close',id:id,result:which_one.val()})
  if which_one.get()[0].parentNode.parentElement.children.length == 1
    which_one.parentNode.parentElement.style.display = 'none'
  else
    removeIt(which_one.parentNode)


