jQuery ->
  unless checkPage(getHomeName()) then return
  $('#gotoforum').click ->
    startForum()
  $('#close-forum').click ->
    closeForum()
  $('#forum-senate').delegate 'img[id = forum-photo]','click', (evt) ->
    playPhoto(event.target)
  $('#forum-senate').delegate 'img[id = forum-photo]','mouseenter', (evt) ->
    makePhotoBig(event.target,true)
  $('#forum-senate').delegate 'img[id = forum-photo]','mouseleave', (evt) ->
    makePhotoBig(event.target,false)
  $('#forum-topic').change ->
    getSenate()
  $('#forum-language').change ->
    getSenate()
  $('#forum-category').change ->
    changeTopic()

window.startForum = ->
  hideMe({id: showPageName()})
  blockMe({id: 'forum-page'})
  clearSenate()
  showMe({id:'forum-category'})
  $.post('forum_ajax', {function: 'get topics', category: 'select category', hold_test: true, restricted: true},loadList)
  comment_span = document.getElementById('forum-comment-span')
  comment_span.dataset.translating == 'false'
  hideMe({obj: comment_span})
  $.post('forum_ajax', {function:'categories', language: getLanguage(),list:'forum-category', hold_test: true, restricted: true},loadList)
  $.post('forum_ajax', {function:'categories', language: getLanguage(),list:'forum-category-admin', hold_test: false, restricted: false},loadList)
  $.post('forum_ajax', {function:'categories', language: getLanguage(),list:'forum-category-monitor', hold_test: false, restricted: false},loadList)
  $.post('forum_ajax',{function:'get language set',list:'forum-language',active:true,by_name:false},loadList)
  $.post('forum_ajax',{function:'get language set',list:'forum-translation-language',active:true},loadCustomList)

closeForum = ->
  hideMe({id: 'forum-page'})
  blockMe({id: showPageName()})
  clearSenate()
  setCategory(0)
  setTopic(0)
  changeTopic()
  cancelComment()
  $('#forum-comment').val('')
  if $('#comment-maybe')?
    $('#comment-maybe').remove()
  hideMe({id: 'comment-span'})
  hideMe({id: 'forum-senate-admin-lists'})
  hideMe({id: "forum-senate-admin-users"})
  blockMe({id: 'forum-senate'})

loadCustomList=(params)->
  if params?
    list_data = params.list_data
    selector = document.getElementById('forum-translation-choices')
    $(selector).children().remove()
    for i in [0...list_data.length]
      option = document.createElement('LI')
      option.dataset.choice = list_data[i].item
      option.dataset.display= list_data[i].value
      option.innerHTML=list_data[i].value
      selector.appendChild(option)
      option.id='forum-translation-choice'
      option.classList.add('drop-menu')

window.loadList = (params)->
  if params? && params.list_data?
    list_data = params.list_data
    if params.name != undefined
      selector= $("[name="+params.name+"]")
    else if params.id !=undefined
      selector = $(document.getElementById(params.id))
    else if params.obj !=undefined
      selector=$(params.obj)
    selector.children().remove()
    for i in [0...list_data.length]
      unless list_data[i].state == 'closed'
        pushOption(selector,list_data[i], 0)

window.pushOption = (q_selector,data,offset)->
  selector=q_selector.get()[0]
  if selector?
    option = document.createElement("option")
    option.text = data.value
    option.value = data.item
    option.id =  'forum-admin-option'
    ref = selector.children[selector.children.length - offset]
    if ref==undefined
      selector.appendChild(option)
    else
      selector.insertBefore(option,ref)
  else
    alert "#{params.list} #{params.by_name}  is not there"


window.getLanguage = ->
  getSelectValues({id:'forum-language', ref:true})

window.getTopic = ->
  document.getElementById('forum-topic').value

window.getCategory = ->
  document.getElementById('forum-category').value

window.setTopic = (index)->
  topic = $('select[id = forum-topic]').get()[0]
  topic.selectedIndex= index

window.setCategory = (index)->
  category = $('select[id = forum-category]').get()[0]
  category.selectedIndex= index

window.clearSenate = ->
  children = $('#just-a-comment')
  if children?
    $('span[id = just-a-comment]').remove()
  deleteMyData(document.getElementById('forum-senate'))
  hideMe({id: 'forum-voting-booth'})
  hideMe({id: 'subscribe-forum'})
  hideMe({id: 'unsubscribe-forum'})
  hideMe({id: 'add-new-thing-span'})
  hideMe({id: 'forum-senate-admin'})
  document.getElementById('forum-senate').dataset.admining = 'false'

window.setSenate = (params)->
  page = document.getElementById('forum-senate')
  showMe({id: '#forum-senate'})
  document.getElementById('forum-comment-span').dataset.next_id = params.index
  kids = $(page).children()
  unless !params.the_list?
    for i in [0...kids.length]
      unless kids[i].id == 'forum-comment-span'
        removeMe({obj:kids[i]})
    unless params.the_list.length == 0
      for i in [0...params.the_list.length]
        buildSpan(page, i, params.the_list[i])

buildSpan = (page, index, params) ->
  span = document.createElement('span')
  if index == 0
    span.className = 'forum-topic'
    page.dataset.moderator = params.moderator
    if params.moderator then $.post('forum_ajax',{function:'get translations',topic:getTopic(),language:getTranslationLanguage()},saveTranslationSuggestions)
    if params.subscribed? then setSubscriber(params.subscribed)
    if params.vote then  setUpVoting({vote: params.vote, votes: params.votes})
    if params.moderator then showMe({id: 'review-forum-span'})
    if params.review then page.dataset.review = true
  else  span.className = "forum-comment"
  span.id = "just-a-comment"
  indexes=Object.keys(params)
  for k in [0...indexes.length]
    unless indexes[k]=='empty_list'
      span.dataset[indexes[k]]=params[indexes[k]]
  the_list=JSON.parse(params.empty_list)
  span.dataset.needy_list= JSON.stringify(the_list)  #convert to javascript friendly JSON
  span.style.textIndent = "#{params.indent * 20}px"
  if page.dataset.moderator == 'true' && params.comment_state == 'new'
    da_class = 'comment-new'
  else if page.dataset.moderator == 'true' && params.comment_state == 'reject'
    da_class = 'comment-reject'
  else  da_class = 'forum-comment'
  span.innerHTML = "<p class = '#{da_class}'>" + params.content + '<span name = owner-of-record class = right>' + params.owner_name + '</span></p>'
  page.appendChild(span)
  if params.has_photo
    putPhotoIn(span,params.photos)
  if params.hyperlinks?
    hyperlinks=params.hyperlinks
    for i in [0...hyperlinks.length]
      writeLink(hyperlinks[i],span)

window.getSelectedId = ->
  if  window.getSelection != undefined
    sel = window.getSelection()
    unless sel== null
      span = sel.anchorNode.parentNode.parentElement
      if sel.rangeCount
        container = document.createElement("div")
        for  i in [0...sel.rangeCount]
          container.appendChild(sel.getRangeAt(i).cloneContents())
        html = container.innerHTML
  else if  document.selection != undefined
    if (document.selection.type == "Text")
      html = document.selection.createRange().htmlText
  unless span?
    spans = $('#forum-senate span')
    if spans.length > 0
      span = spans[spans.length - 1]
  {selection: html, id: span.dataset.id}

putPhotoIn=(span,urls)->
  span.dataset.already_has_photo=true
  for i in [0...urls.length]
    img= new Image
    img.src=urls[i]
    img.className= 'forum-photo'
    img.id='forum-photo'
    paragraph=span.children[0]
    paragraph.appendChild(img)

makePhotoBig=(photo,bigger)->
  if bigger
    x=photo.x
    ref=photo.width+x
    photo.classList.add('forum-big-photo')
    photo.classList.remove('forum-photo')
    photo.style.position='relative'
    photo.style.left=x+'px'
    b=-113
    m=0.16129
    error=$(window).width()*m+b
    new_left= ref-photo.width-error
    if new_left<40 then new_left=40
    photo.style.left= new_left+'px'

  else
    photo.classList.remove('forum-big-photo')
    photo.classList.add('forum-photo')
    photo.style.left=''
    photo.style.position=''

playPhoto=(photo)->
  photo.src=photo.src
  event.stopPropagation()

askForPhotAgain=(params)->
  $.post('forum_ajax',{function:'get forum photo',tag:params.tag,edit:params.edit,count:params.count,id:params.id,parent:params.parent},needAPhoto)

window.needAPhoto=(params)->
  if params.urls.length > 0
    setMaybeId(params)
    if params.edit=='true'
      span=$('[data-id='+params.id+']').get()[0]
    else
      span=$("[data-tag=#{params.tag}]").get()[0]
    putPhotoIn(span,params.urls)
  else #if params.count < 20
    setTimeout (-> askForPhotAgain(params)), 2000

getSenate = ->
  clearSenate()
  select = document.getElementById('forum-topic').value
  if select == 'request new topic'
    addNewThing({'forum-topic'})
  else
    document.getElementById('forum-senate').dataset.topic = select
    $.post('forum_ajax', {function: 'get senate',language:getLanguage(), topic: select}, setSenate)


addNewThing = (select)->
  $('#add-new-thing-input').val('')
  showMe({id: 'add-new-thing-span'})
  hideMe({id: 'forum-senate'})
  $('#add-new-thing-span').data.thing = select

window.changeTopic = ->
  setTopic(0)
  select = document.getElementById('forum-category').value
  hideMe({id: 'forum-senate-admin-lists'})
  hideMe({id:'forum-senate-admin-users'})
  clearSenate()
  if select == 'request new category'
    addNewThing('forum-category')
  else if select == 'admin'
    doAdminStuff()
  else if select != 'select category'
    blockMe({id: 'forum-senate'})
    hideMe({id: 'forum-senate-admin'})
    document.getElementById('forum-senate').dataset.category = select
    $.post('forum_ajax', {function: 'get topics',list:'forum-topic', category: select, hold_test: true, restricted: true}, loadList)

