class ApplicationController < ActionController::Base

  include ApplicationHelper
  include SharedCode
  before_filter :set_locale

  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
  # Force signout to prevent CSRF attacks

  def handle_unverified_request
    sign_out
    super
  end

  private
  def set_locale
    I18n.locale = params[:locale] if params[:locale].present?
  end
  def default_url_options(options = {})
    {locale: I18n.locale}
  end
end
