#
#  id          :integer          not null, primary key
#  user_id     :integer
#  centurians  :binary
#  subscribers :binary
#  topic       :string(255)
#  root        :boolean
#  index       :integer
#  content     :text
#  parent      :integer
#  resolution  :string(255)
#  state       :string(255)

class ForumsController < ApplicationController
  def forum_ajax
    if signed_in_user?
      case params[:function]
        when 'get list'
          case params[:list]
            when 'admin actions' then
              render json: Forum.get_forum_actions(params, current_user.id)
            when 'admin users' then
              render json: ForumPeopleList.get_forum_users(params, current_user.id)
            when 'admin emails' then
              render json: ForumPeopleList.get_forum_emails(params, current_user.id)
            when 'admin distributions' then
              render json: ForumPeopleList.get_forum_distribution_lists(current_user.id)
            else
          end
        when 'forum admin action'
          render json: Forum.do_admin_action(params, current_user.id)
        when 'categories'
          render json: ForumCategory.categories(params, current_user.id)
        when 'post'
          render json: Forum.add_comment(params, current_user.id)
        when 'get forum photo'
          render json: ForumPhoto.get_photo(params)
        when 'add hot link'
          render json:ForumHyperlink.add_one(params)
        when 'get language set'
          render json: ForumLanguage.languages(params)
        when 'toggle language'
          render json: ForumLanguage.toggle_language(params, current_user.id)
        when 'get translations'
          render json: ForumTranslation.get_translations(params)
        when 'add to list'
          case params[:list]
            when 'category'
              response=ForumCategory.add_category(params, current_user.id)
            when 'topic'
              response=ForumTopic.add_topic(params, current_user.id)
            when 'langauge'
              response= ForumLanguage.activate_language(params, current_user.id)
            else
          end
          render json: response
        when 'get senate'
          render json: Forum.senate(params, current_user.id)
        when 'get topics'
          render json: ForumTopic.topics(params, current_user.id)
        when 'accept', 'reject'
          render json: Forum.change_state(params, current_user.id)
        when 'edit forum topic'
          render json: ForumTopic.edit_topic(params, current_user.id)
        when 'remove forum object'
          case params[:which_list]
            when 'category'
              response=ForumCategory.remove_object(params, current_user.id)
            when 'topic'
              response=ForumTopic.remove_object(params, current_user.id)
            when 'language'
              response=ForumLanguage.deactivate_language(params, current_user.id)
            else
          end
          render json: response
        when 'vote'
          render json: {votes: ForumTopic.cast_vote(params[:topic], current_user.id, params[:vote])}
        when 'add voting'
          render json: ForumTopic.voting_booth?(params)
        when 'subscribe'
          render json: ForumTopic.subscribe(params[:topic], current_user.id)
        when 'get suggestions'
          case params[:ist]
            when 'category'
              response=ForumCategory.get_suggestions(params, current_user.id)
            when 'topic'
              response=ForumTopic.get_suggestions(params, current_user.id)
            when 'language'
              response=ForumLanguage.get_suggestions(params, current_user.id)
            else
          end
          render json: response
        when 'suggestion'
          case params[:list]
            when 'category'
              response=ForumCategory.suggestions(params, current_user.id)
            when 'topic'
              response=ForumTopic.suggestions(params, current_user.id)
            when 'language'
              response=ForumLanguage.suggestions(params, current_user.id)
            else
          end
          render json: response
        when 'suggestion close'
          case params[:list]
            when 'category'
              response=ForumCategory.suggestion_close(params, current_user.id)
            when 'topic'
              response=ForumTopic.suggestion_close(params, current_user.id)
            when 'language'
              response=ForumLanguage.suggestion_close(params, current_user.id)
            else
          end
          render json: response
        when 'set_the_rest'
          render json: Forum.set_the_rest(params, current_user.id)
        else
          render json: {answer: 'what did you want'}
      end
    else
      render json: {chill_out: 'chill_out'}
    end
  end

  def newforum_photo
    ForumPhoto.upload(params,current_user.id)
  end


end
