# == Schema Information
#
# Table name: forum_categories
#
#  id         :integer          not null, primary key
#  user_id    :integer
#  name       :string(50)
#  state      :string(50)
#  suggestion :boolean
#  closed     :boolean          default(FALSE)
#  created_at :datetime
#  updated_at :datetime
#

class ForumCategory < ActiveRecord::Base
  include  ForumSharedCode
  require 'json'

  has_many :forum_topics, dependent: :destroy
  has_many :forum_people_lists, dependent: :destroy

  def self.add_category(params,user_id)
    params[:user_id]=user_id if params[:user_id] == 'me'
    User.forum_admin?(user_id) ? id= ForumCategory.create(name:params[:new_item]).id : 'not happening'
    {id:id}
  end

  def self.remove_category(params,user_id)
    case(params[:state_action])
      when 'del'  then Forum.where(id:params[:id]).update_all(closed:true)
      when 'open' then Forum.where(id:params[:id]).update_all(closed:false)
      else
        # type code here
    end  if User.forum_admin?(user_id)
    {action:'nothing to do'}
  end

  def self.get_suggestion(params,user_id)
      data= ForumCategory.where(state:'suggestion').pluck(:suggestion, :user_id,:id,:owner_name)
      data=ForumAssist.named_array(data, [:suggestion, :user,:id, :owner_name], d2=true) unless data.empty?
      data=Forum.add_user_name(data.clone) unless data.empty?
      User.forum_admin?(user_id) ? {data: data, list: 'category-prososals-list'} : {response: 'nothing doing'}
  end

  def self.suggestion(params,user_id)  #add new category or topic
    ForumCategory.create(suggestion:true,content:params[:suggestion],user_id:user_id,hold:true)
    {response:'nothing to do'}
  end

  def self.suggestion_close(params,user_id)
    ForumCategory.where(id:params[:id]).update_all(state:'closed') if User.forum_admin?(user_id)
  end

  def self.categories(params,user_id)
    if ForumCategory.first.nil?
      ForumCategory.create(name:'request new category',closed:false)
      ForumCategory.create(name:'select category',closed:false)
    end
    params[:hold_test]=='true' ?
        category_list= ForumAssist.named_array(ForumCategory.where(closed:false).pluck(:id,:name,:closed),[:id,:name,:closed],d2=true)   :
        category_list= ForumAssist.named_array(ForumCategory.all.pluck(:id,:name,:closed),[:id,:name,:closed],d2=true)
    category_list=ForumAssist.make_last(category_list.clone, {key: :id,ref:ForumCategory.where(name:'request new category').pluck(:id)[0]})
    category_list=ForumAssist.make_first(category_list.clone,{key: :id,ref:ForumCategory.where(name:'select category').pluck(:id)[0]})
    category_list=ForumPeopleList.check_restrictions(category_list.clone,user_id) if params[:restricted]=='true'
    category_list=ForumTranslation.translate_list(category_list.clone,params[:language],'category')
    category_list.push({id:0, item:'admin',value: I18n.t('forum.Admin_name')}) if User.forum_admin?(user_id)
    {list_data:category_list,id:params[:list]}
  end

end
