# == Schema Information
#
# Table name: forum_photos
#
#  id         :integer          not null, primary key
#  forum_id   :integer
#  user_id    :integer
#  name       :string(50)
#  resized    :boolean          default(FALSE)
#  key        :string(255)
#  created_at :datetime
#  updated_at :datetime
#

class ForumPhoto < ActiveRecord::Base
  include  ForumSharedCode
  require 'json'

  belongs_to :user
  belongs_to :forum

  def self.get_photos(forum_id)
    photos=ForumPhoto.where(forum_id:forum_id).pluck(:key)
    urls=[]
    photos.each {|photo|
      urls.push(ForumAssist.get_url(photo)  )
    }
    urls
  end

  def self.get_photo(params)
    params[:id].nil? ? which = {tag:params[:tag]}  : which = {id:params[:id]}
    data=ForumAssist.named_array(Forum.where(which).pluck(:id,:parent)[0],[:id,:parent],d2=false)
    urls=ForumPhoto.get_photos(data[:id])
    {tag:params[:tag],edit:params[:edit],urls:urls,id:data[:id],parent:data[:parent],count:params[:count].to_i+1}
  end

  def self.upload(params,user_id)
    temp=JSON.load(params[:forum_photo][:data])
    pforward=Hash[temp.map{|k,v| [k.to_sym,v]}]  #make the true/false strings again
    pforward[:needs] ? pforward[:needs_photo] ='true' : pforward[:needs_photo] ='false'
    pforward[:already_has_photo] ? pforward[:already_has_photo] ='true' : pforward[:already_has_photo] ='false'
    pforward[:edit] ? pforward[:edit] ='true' : pforward[:edit] ='false'
    pforward[:translating] ? pforward[:translating] ='true' : pforward[:translating] ='false'
    comment_info=Forum.add_comment(pforward,user_id)
    k=params[:forum_photo][:file]
    Spawnling.new {
      (0...k.size).each {|i|
        name=k[i].original_filename.downcase
        ext=name.split('.').last
        if %w(jpg gif png).include?(ext)
          folder='doll/forum_photos'
          save_name=File.join(folder,name)
          ForumAssist.save_image(k[i].tempfile.path, save_name)
          ForumPhoto.create(user_id:user_id,forum_id:comment_info[:id],name:name,key:save_name)
        end
      }
    } unless k.nil?
    Rails.logger.debug 'saved job, now going back'
  end

end
